//      . 
//  
function daysInMonth(month, year){
return 32 - new Date(month, year, 32).getDate();
}

function makeDay(d){
if(d < 10)
d = "0" + d;
return d + "    ";
}

// 
width = 1280;
height = 800;
resolution = 72;
docName = "PhotoshopScriptCalendar";
year = 2010;

//C 
normalColor = new SolidColor();
normalColor.rgb.hexValue = "FFFFFF";
highlightColor = new SolidColor();
highlightColor.rgb.hexValue = "A4B1D1";
backColor = new SolidColor();
backColor.rgb.hexValue = "1B4392";

//    
monthHeader = "                  \r\r";  //    
sundayHeader = "\r\r"; 
//       Enter,          .  
firstIndent = "         ";  
//             (  ,         )
months = new Array("", "", "", "", "", "", "", "", "", "", "", "");

//  
doc = app.documents.add(width, height, resolution,
docName, NewDocumentMode.RGB);
doc.selection.selectAll();
doc.selection.fill(backColor);
doc.selection.deselect();

//  
file = app.openDialog();

if(file[0]){
app.load(file[0]);
backFile = app.activeDocument;
backFile.resizeImage(width, height);
backFile.selection.selectAll();
backFile.selection.copy();
backFile.close(SaveOptions.DONOTSAVECHANGES);
doc.paste();
doc.layers[0].name = " ";
}

for(curr=0; curr<12; curr++){

x = curr % 4;
y= Math.floor(curr / 4);

group = doc.layerSets.add();
group.name = months[curr];

monthName = group.artLayers.add();
monthName.kind = LayerKind.TEXT;
monthName.name = months[curr];
monthName.textItem.color = normalColor;
monthName.textItem.size = 27;
monthName.textItem.kind = TextType.PARAGRAPHTEXT;
monthName.textItem.justification = Justification.RIGHT;
monthName.textItem.height = 35;
monthName.textItem.width = 145;
monthName.textItem.contents = months[curr];
monthName.rotate(-90);
monthName.textItem.position = new Array(55 + 300 * x, (202 + (210 * y)));

days = group.artLayers.add();
days.kind = LayerKind.TEXT;
days.name = "Days";
days.textItem.Justification = Justification.CENTER;
days.textItem.color = normalColor;
days.textItem.size = 19;
days.textItem.position = new Array(80 + (300 * x), 70 + (210 * y));

sundays = group.artLayers.add()
sundays.kind = LayerKind.TEXT;
sundays.name = "Sundays";
sundays.textItem.Justification = Justification.CENTER;
sundays.textItem.color = highlightColor;
sundays.textItem.size = 19;
sundays.textItem.position = new Array(300 + (300 * x), 70 + (210 * y));

text = monthHeader;
textSun = sundayHeader;

startDate = new Date(year, curr, 1);
n = startDate.getDay();

for(i=0; i<n-1; i++)
text += firstIndent;

d = 1;
while(d <= daysInMonth(curr, year)){
if(i == 6)
textSun += makeDay(d) + "\r";
else{
text += makeDay(d);
if(i == 5)
text += "\r";
}
i++;
d++;
if(i == 7)
i = 0;
}

days.textItem.contents = text;
sundays.textItem.contents = textSun;
}

//     
yearLayer = doc.artLayers.add();
yearLayer.kind = LayerKind.TEXT;
yearLayer.name = year;
yearLayer.textItem.contents = year;
yearLayer.textItem.size = 72;
yearLayer.textItem.color = highlightColor;
yearLayer.textItem.position = new Array(1050, 730);

//  
line = doc.artLayers.add();
line.name = "Line";
region = Array(Array(80, 729), Array(1000, 729), Array(1000, 730), Array(80, 730));
doc.selection.select(region);
doc.selection.fill(normalColor)
doc.selection.deselect();